<template>
  <ContentWrapper>
    <div class="content-heading">
      <div>Relação de usuários
        <ol class="breadcrumb breadcrumb px-0 pb-0">
          <li class="breadcrumb-item active">
            <a href="/users" @click.prevent="$router.push({path:'/users'})">Usuários</a>
          </li>
        </ol>
      </div>
    </div>
    <div class="card">
      <!-- <div class="card-header">
        <div class="card-title">Relação de usuários</div>
        <div class="text-sm"></div>
      </div>-->
      <div :class="'card-body'+(process.list ? ' whirl duo':'')">
        <Datatable
          v-if="!process.list"
          :options="dtOptions"
          class="table table-striped my-4 w-100"
          id="datatable"
        >
          <thead>
            <tr>
              <th>#</th>
              <th data-priority="1">Nome</th>
              <th>CPF</th>
              <th>email</th>
              <th class="sort-alpha">Cidade</th>
              <th class="sort-alpha">UF</th>
              <th>Ações</th>
            </tr>
          </thead>
          <tbody>
            <tr v-for="user in users" :key="user.id">
              <td>{{user.id}}</td>
              <td>{{user.name}}</td>
              <td>{{user.cpf}}</td>
              <td>{{user.email}}</td>
              <td>{{user.address_city}}</td>
              <td>{{user.address_state}}</td>
              <td>
                <div class="btn-group">
                  <button
                    id="btnEdit"
                    class="btn btn-info btn-sm"
                    type="button"
                    @click="edit(user)"
                  >
                    <em style="padding:5px" class="fas fa-user-edit"></em>
                  </button>
                  <!-- <b-tooltip :target="'btnEdit'" triggers="hover focus" :title="'Editar usuário'"/> -->

                  <button class="btn btn-danger btn-sm" type="button" @click="remove(user)">
                    <em class="fas fa-user-alt-slash" style="padding:5px"></em>
                  </button>
                  <!-- <button
                    id="btnExcluir"
                    class="btn btn-danger"
                    type="button"
                    @click="remove(user)"
                  >
                    <em style="padding:5px" class="fas fa-user-alt-slash"></em>
                  </button> -->
                  <!-- <b-tooltip
                    :target="'btnExcluir'"
                    triggers="hover focus"
                    :title="'Excluir usuário'"
                  />-->
                </div>
              </td>
            </tr>
          </tbody>
        </Datatable>
      </div>
    </div>
  </ContentWrapper>
</template>
<script>
import Datatable from "@/components/Tables/Datatable";

import UserService from "@/domain/user/UserService";
import Uf from "@/domain/uf/Uf";

import NotificationProvider from "@/provider/NotificationProvider";
import swal from "sweetalert2";

export default {
  name: "user-list",
  components: {
    Datatable
  },
  created() {
    this.process.list = true;
    this.userService
      .list(10, 1)
      .then(response => {
        this.users = response;
        this.process.list = false;
      })
      .catch(err => {
        console.log(JSON.stringify(err));
        this.notificationProvider.error(
          "Falha na comunicação",
          "Falha ao listar os usuários"
        );
        this.process.list = false;
      });
  },
  data() {
    return {
      ufs: Uf.ufs,
      users: [],
      userService: new UserService(),
      notificationProvider: new NotificationProvider(this.$notify),
      dtOptions: {
        paging: true, // Table pagination
        ordering: true, // Column ordering
        info: true, // Bottom left status text
        responsive: true,
        // Text translation options
        // Note the required keywords between underscores (e.g _MENU_)
        oLanguage: {
          sSearch: '<em class="fa fa-search"></em>',
          sLengthMenu: "_MENU_ registros por página",
          info: "Página _PAGE_ de _PAGES_",
          zeroRecords: "Nada encontrado",
          infoEmpty: "Nenhum registro",
          infoFiltered: "(Filtrado de _MAX_ itens)",
          oPaginate: {
            sNext: '<em class="fa fa-caret-right"></em>',
            sPrevious: '<em class="fa fa-caret-left"></em>'
          }
        },
        // Datatable key setup
        keys: false
      },
      process: {
        list: false
      }
    };
  },
  methods: {
    remove(user) {
      swal({
        title: "Deletar " + user.id + "#" + user.name + "? ",
        text: "Não será possível recuperar!",
        type: "warning",
        showCancelButton: true,
        confirmButtonColor: "#DD6B55",
        confirmButtonText: "Sim, deletar!"
      }).then(result => {
        if (result.value) {
          this.userService
            .delete(user.id)
            .then(response => {
              this.users.forEach((el, index) => {
                if (user.id == el.id) {
                  this.users.splice(index, 1);
                }
              });
              this.notificationProvider.success(
                "Deletado",
                "Usuário " + user.name + " deletado com sucesso!"
              );
            })
            .catch(err => {
              if (
                err.response &&
                err.response.data &&
                err.response.data.message &&
                err.response.data.message.indexOf(
                  "Integrity constraint violation"
                )
              ) {
                // erro de vinculo no banco
                this.notificationProvider.error(
                  "Não é possível remover",
                  "Existem registros vinculados a este registro"
                );
              } else {
                console.log(JSON.stringify(err));
                this.notificationProvider.error(
                  "Falha ao remover",
                  "Não foi possível remover este registro"
                );
              }
            });
        }
      });
    },
    edit(user) {
      // editando usuario
      this.$router.push({ path: "/user/" + user.id });
    }
  }
};
</script>